## 96e1df9bd27c.zip

=== Makefile ===
# Phil's multiplatform makefile template
# With auto-incrementing build number and automatic version.h generation
# Version 1.4, 2009-01-27
#
# The latest version of this Makefile can be found at http://www.philpem.me.uk/
#
#
# Copyright (c) 2009 Philip Pemberton <code@philpem.me.uk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
#
# Instructions for use:
#   Run 'make init' to create the required directories
#   Add your source files to the 'SOURCES' list, and change the TARGET filename
#   Set the desired build type and platform in the BUILD_TYPE and PLATFORM
#     variables respectively
#   Set your project type (C only, or C++) in the SRC_TYPE variable
#   Add any libraries you need to link against to the 'LIB' list
#   Run 'make'
#
# Object files are created in the 'obj' subdirectory, from source code in the
# 'src' directory. Dependency files are created in the 'dep' directory from
# the same source code the object files are created from.
#
# Supported targets are:
#   all                 Build everything.
#   update-revision     Increment the build number without building anything.
#   clean-versioninfo   Delete src/version.h (will be rebuilt on the next
#                       'make all').
#   init                Initialise the build system for a new project.
#                       WARNING: overwrites .buildnum and src/version.h.in!
#   cleandep            Delete all dependency files.
#   clean               Delete all dependency, intermediate and target files.
#   tidy                Delete all dependency and intermediate files, leaving
#                       the target file intact.
#
# If you want to reset the build number to zero, delete '.buildnum'. This
# should be done whenever the major or minor version changes. Excluding
# .buildnum from version control may also be a good idea, depending on how
# you want your build numbers to work.
#
# The BUILD_TYPE variable contains the current build type. There are two
# supported build types:
#   debug       Debug mode - object files are compiled with debug information
#               and the target is left unstripped.
#   release     Release mode - object files are not compiled with debug info,
#               and the target is fed through strip to remove redundant
#               data.
#
# The PLATFORM variable contains the current target platform. There are two
# supported platforms:
#   linux       GNU/Linux with GNU Compiler Collection
#   win32       Windows 32-bit with MinGW
#
# The EXTSRC variable is used to specify other files to build. It is typically
# used to specify platform or build-type specific source files, e.g.
#
# ifeq ($(BUILD_TYPE),debug-memwatch)
#   CFLAGS += -g -ggdb
#   CPPFLAGS += -DMEMWATCH
#   INCPATH += ./memwatch
#   EXTSRC += memwatch/memwatch.c
# endif
#
# (example taken from one of my projects that allowed the use of Memwatch to
#  track down memory allocation/deallocation bugs)
#

####
# Build configuration
####

# version information -- major.minor.extra
# note that VER_EXTRA can be overridden on the command line, e.g.:
# make VER_EXTRA=12345 all
VER_MAJOR	= 0
VER_MINOR	= 0
VER_EXTRA	?= 

# build platform: win32 or linux
PLATFORM	?=	linux
# build type: release or debug
BUILD_TYPE	?=	debug

# target executable
TARGET		=	ptouch

# source files that produce object files
SRC			=	main.c hexdump.c ptouch.c

# source type - either "c" or "cpp" (C or C++)
SRC_TYPE	=	c

# additional object files that don't necessarily include source
EXT_OBJ		=
# libraries to link in -- these will be specified as "-l" parameters, the -l
# is prepended automatically
#LIB			=	jpeg tiff png z
LIB			=	gd
# library paths -- where to search for the above libraries
LIBPATH		=
# include paths -- where to search for #include files (in addition to the
# standard paths
INCPATH		=
# garbage files that should be deleted on a 'make clean' or 'make tidy'
GARBAGE		=

# extra dependencies - files that we don't necessarily know how to build, but
# that are required for building the application; e.g. object files or
# libraries in sub or parent directories
EXTDEP		=

####
# Win32 target-specific settings
####
ifeq ($(strip $(PLATFORM)),win32)
	# windows executables have a .exe suffix
	TARGET := $(addsuffix .exe,$(TARGET))
	# console mode application
	EXT_CFLAGS = -mconsole
	# additional libraries required by CImg on win32
	LIB += gdi32
endif

####
# Linux target-specific settings
####
ifeq ($(strip $(PLATFORM)),linux)
	# additional libraries required by CImg on linux
	LIB += m pthread X11
endif


####
# Tool setup
####
MAKE	=	make
CC		=	gcc
CXX		=	g++
CFLAGS	=	-Wall -pedantic -std=gnu99 $(EXT_CFLAGS)
CXXFLAGS=	-Wall -pedantic $(EXT_CXXFLAGS)
LDFLAGS	=	$(EXT_LDFLAGS)
RM		=	rm
STRIP	=	strip

###############################################################################
# You should not need to touch anything below here, unless you're adding a new
# platform or build type (or changing the version string format)
###############################################################################

####
# A quick sanity check on the platform type
####
ifneq ($(PLATFORM),linux)
ifneq ($(PLATFORM),win32)
    $(error Platform '$(PLATFORM)' not supported. Supported platforms are: linux, win32)
endif
endif

####
# Version info generation
####
# get the current build number
VER_BUILDNUM	= $(shell cat .buildnum)

# there are two ways to get the SVN rev - use svnversion, or use svn info
# then pipe through awk. which one you use is up to you.
VER_SVNREV		= $(shell LANG=C svn info 2>/dev/null || echo 'Revision: 0' | awk '/^Revision:/ { print$$2 }' )
#VER_SVNREV		= $(shell svnversion .)

# if the version string is "exported", then the CSD was not checked out of SVN
# note that if the CSD is not an SVN checkout, then @@svnrev@@ will be set to
# zero.
ifeq ($(VER_SVNREV),exported)
    VER_SVNREV	= 0
endif

# start creating the revision string
VER_FULLSTR		= $(VER_MAJOR).$(VER_MINOR).$(VER_BUILDNUM)$(VER_EXTRA)

# if this is an SVN release, include the SVN revision in the version string
ifneq ($(VER_SVNREV),0)
    VER_FULLSTR	+= (svn $(VER_SVNREV))
endif


####
# Build-type specific configuration
####
ifeq ($(BUILD_TYPE),debug)
	CFLAGS		+= -g -ggdb
	CXXFLAGS	+= -g -ggdb
else
 ifeq ($(BUILD_TYPE),release)
	CFLAGS		+= -O2
	CXXFLAGS	+= -O2
 else
 	$(error Unsupported build type: '$(BUILD_TYPE)')
 endif
endif

####
# rules
####

# object files
OBJ		=	$(addprefix obj/, $(addsuffix .o, $(basename $(SRC))) $(EXT_OBJ)) $(addsuffix .o, $(basename $(EXTSRC)))

# dependency files
DEPFILES =	$(addprefix dep/, $(addsuffix .d, $(basename $(SRC))) $(EXT_OBJ)) $(addsuffix .d, $(basename $(EXTSRC)))

# path commands
LIBLNK	=	$(addprefix -l, $(LIB))
LIBPTH	=	$(addprefix -L, $(LIBPATH))
INCPTH	=	$(addprefix -I, $(INCPATH))

CPPFLAGS +=	$(INCPTH)

####
# Make sure there is at least one object file to be linked in
####
ifeq ($(strip $(OBJ)),)
    $(error Unable to build: no object or source files specified in Makefile)
endif

####
# targets
####
.PHONY:	default all update-revision versionheader clean-versioninfo init cleandep clean tidy

all:	update-revision
	@$(MAKE) versionheader
	$(MAKE) $(TARGET)

# increment the current build number
NEWBUILD=$(shell expr $(VER_BUILDNUM) + 1)
update-revision:
	@echo $(NEWBUILD) > .buildnum

versionheader:
	@sed -e 's/@@date@@/$(shell LC_ALL=C date)/g'			\
		 -e 's/@@time@@/$(shell LC_ALL=C date +%T)/g'		\
		 -e 's/@@whoami@@/$(shell whoami)/g'				\
		 -e 's/@@hostname@@/$(shell hostname)/g'			\
		 -e 's|@@compiler@@|$(shell $(CC) $(CFLAGS) -v 2>&1 | tail -n 1 | sed -e "s;|;/;")|g'	\
		 -e 's/@@majorver@@/$(VER_MAJOR)/g'					\
		 -e 's/@@minorver@@/$(VER_MINOR)/g'					\
		 -e 's/@@extraver@@/$(subst \",,$(VER_EXTRA))/g'	\
		 -e 's/@@buildnum@@/$(VER_BUILDNUM)/g'				\
		 -e 's/@@buildtype@@/$(BUILD_TYPE)/g'				\
		 -e 's/@@svnrev@@/$(VER_SVNREV)/g'					\
		 -e 's/@@fullverstr@@/$(VER_FULLSTR)/g'				\
		 -e 's/@@cflags@@/$(CFLAGS)/g'						\
		 < src/version.h.in > src/version.h

# version.h creation stuff based on code from the Xen makefile
clean-versioninfo:
	@if [ ! -r src/version.h -o -O src/version.h ]; then \
		rm -f src/version.h; \
	fi
	@echo 0 > .buildnum

# initialise the build system for a new project
init:
	@mkdir -p src dep obj
	@echo 0 > .buildnum
	@echo '#define VER_COMPILE_DATE	"@@date@@"'				> src/version.h.in
	@echo '#define VER_COMPILE_TIME	"@@time@@"'				>> src/version.h.in
	@echo '#define VER_COMPILE_BY		"@@whoami@@"'		>> src/version.h.in
	@echo '#define VER_COMPILE_HOST	"@@hostname@@"'			>> src/version.h.in
	@echo '#define VER_COMPILER		"@@compiler@@"'			>> src/version.h.in
	@echo '#define VER_BUILD_TYPE		"@@buildtype@@"'	>> src/version.h.in
	@echo '#define VER_CFLAGS			"@@cflags@@"'		>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo '#define VER_MAJOR			@@majorver@@'		>> src/version.h.in
	@echo '#define VER_MINOR			@@minorver@@'		>> src/version.h.in
	@echo '#define VER_BUILDNUM		@@buildnum@@'			>> src/version.h.in
	@echo '#define VER_EXTRA			"@@extraver@@"'		>> src/version.h.in
	@echo '#define VER_SVNREV			@@svnrev@@'			>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo '#define VER_FULLSTR			"@@fullverstr@@"'	>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo Build system initialised

# remove the dependency files
cleandep:
	-rm $(DEPFILES)

# remove the dependency files and any target or intermediate build files
clean:	cleandep clean-versioninfo
	-rm $(OBJ) $(TARGET) $(GARBAGE)

# remove any dependency or intermediate build files
tidy:	cleandep clean-versioninfo
	-rm $(OBJ) $(GARBAGE)

#################################

$(TARGET):	$(OBJ) $(EXTDEP)
ifeq ($(SRC_TYPE),c)
	$(CC) $(CXXFLAGS) $(LDFLAGS) $(OBJ) $(LIBPTH) $(LIBLNK) -o $@
else
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(OBJ) $(LIBPTH) $(LIBLNK) -o $@
endif
ifeq ($(BUILD_TYPE),release)
	$(STRIP) $(TARGET)
endif

###
# extra rules
# example:
#src/parser.c:	src/parser.h

####
# make object files from C source files
obj/%.o:	src/%.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $@

##
# make object files from C++ source files
obj/%.o:	src/%.cc
	$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $< -o $@

obj/%.o:	src/%.cpp
	$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $< -o $@

###
# make C files from yacc/bison source
src/%.h src/%.c:	src/%.y
	$(YACC) $(YFLAGS) -d $<
	mv -f y.tab.c $*.c
	mv -f y.tab.h $*.h

###
# make C files from lex/flex source
src/%.c:	src/%.l
	$(LEX) $(LFLAGS) -o$@ $<

###
# make dependencies for our source files
dep/%.d:	src/%.c
	$(CC) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

dep/%.d:	src/%.cpp
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

dep/%.d:	src/%.cc
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

####
# pull in the dependency files, but only for 'make $(TARGET)'
####

ifeq ($(MAKECMDGOALS),$(TARGET))
  -include $(DEPFILES)

=== PTdecode/Makefile ===
# Phil's multiplatform makefile template
# With auto-incrementing build number and automatic version.h generation
# Version 1.4, 2009-01-27
#
# The latest version of this Makefile can be found at http://www.philpem.me.uk/
#
#
# Copyright (c) 2009 Philip Pemberton <code@philpem.me.uk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
#
# Instructions for use:
#   Run 'make init' to create the required directories
#   Add your source files to the 'SOURCES' list, and change the TARGET filename
#   Set the desired build type and platform in the BUILD_TYPE and PLATFORM
#     variables respectively
#   Set your project type (C only, or C++) in the SRC_TYPE variable
#   Add any libraries you need to link against to the 'LIB' list
#   Run 'make'
#
# Object files are created in the 'obj' subdirectory, from source code in the
# 'src' directory. Dependency files are created in the 'dep' directory from
# the same source code the object files are created from.
#
# Supported targets are:
#   all                 Build everything.
#   update-revision     Increment the build number without building anything.
#   clean-versioninfo   Delete src/version.h (will be rebuilt on the next
#                       'make all').
#   init                Initialise the build system for a new project.
#                       WARNING: overwrites .buildnum and src/version.h.in!
#   cleandep            Delete all dependency files.
#   clean               Delete all dependency, intermediate and target files.
#   tidy                Delete all dependency and intermediate files, leaving
#                       the target file intact.
#
# If you want to reset the build number to zero, delete '.buildnum'. This
# should be done whenever the major or minor version changes. Excluding
# .buildnum from version control may also be a good idea, depending on how
# you want your build numbers to work.
#
# The BUILD_TYPE variable contains the current build type. There are two
# supported build types:
#   debug       Debug mode - object files are compiled with debug information
#               and the target is left unstripped.
#   release     Release mode - object files are not compiled with debug info,
#               and the target is fed through strip to remove redundant
#               data.
#
# The PLATFORM variable contains the current target platform. There are two
# supported platforms:
#   linux       GNU/Linux with GNU Compiler Collection
#   win32       Windows 32-bit with MinGW
#
# The EXTSRC variable is used to specify other files to build. It is typically
# used to specify platform or build-type specific source files, e.g.
#
# ifeq ($(BUILD_TYPE),debug-memwatch)
#   CFLAGS += -g -ggdb
#   CPPFLAGS += -DMEMWATCH
#   INCPATH += ./memwatch
#   EXTSRC += memwatch/memwatch.c
# endif
#
# (example taken from one of my projects that allowed the use of Memwatch to
#  track down memory allocation/deallocation bugs)
#

####
# Build configuration
####

# version information -- major.minor.extra
# note that VER_EXTRA can be overridden on the command line, e.g.:
# make VER_EXTRA=12345 all
VER_MAJOR	= 0
VER_MINOR	= 0
VER_EXTRA	?= 

# build platform: win32 or linux
PLATFORM	?=	linux
# build type: release or debug
BUILD_TYPE	?=	debug

# target executable
TARGET		=	ptdecode

# source files that produce object files
SRC			=	main.cpp

# source type - either "c" or "cpp" (C or C++)
SRC_TYPE	=	cpp

# additional object files that don't necessarily include source
EXT_OBJ		=
# libraries to link in -- these will be specified as "-l" parameters, the -l
# is prepended automatically
LIB			=	m pthread X11
# library paths -- where to search for the above libraries
LIBPATH		=
# include paths -- where to search for #include files (in addition to the
# standard paths
INCPATH		=	CImg-1.3.0
# garbage files that should be deleted on a 'make clean' or 'make tidy'
GARBAGE		=

# extra dependencies - files that we don't necessarily know how to build, but
# that are required for building the application; e.g. object files or
# libraries in sub or parent directories
EXTDEP		=

####
# Win32 target-specific settings
####
ifeq ($(strip $(PLATFORM)),win32)
	# windows executables have a .exe suffix
	TARGET := $(addsuffix .exe,$(TARGET))
	# console mode application
	EXT_CFLAGS = -mconsole
endif


####
# Tool setup
####
MAKE	=	make
CC		=	gcc
CXX		=	g++
CFLAGS	=	-Wall -pedantic -std=gnu99 $(EXT_CFLAGS)
CXXFLAGS=	-Wall -pedantic $(EXT_CXXFLAGS)
LDFLAGS	=	$(EXT_LDFLAGS)
RM		=	rm
STRIP	=	strip

###############################################################################
# You should not need to touch anything below here, unless you're adding a new
# platform or build type (or changing the version string format)
###############################################################################

####
# A quick sanity check on the platform type
####
ifneq ($(PLATFORM),linux)
ifneq ($(PLATFORM),win32)
    $(error Platform '$(PLATFORM)' not supported. Supported platforms are: linux, win32)
endif
endif

####
# Version info generation
####
# get the current build number
VER_BUILDNUM	= $(shell cat .buildnum)

# there are two ways to get the SVN rev - use svnversion, or use svn info
# then pipe through awk. which one you use is up to you.
VER_SVNREV		= $(shell LANG=C svn info 2>/dev/null || echo 'Revision: 0' | awk '/^Revision:/ { print$$2 }' )
#VER_SVNREV		= $(shell svnversion .)

# if the version string is "exported", then the CSD was not checked out of SVN
# note that if the CSD is not an SVN checkout, then @@svnrev@@ will be set to
# zero.
ifeq ($(VER_SVNREV),exported)
    VER_SVNREV	= 0
endif

# start creating the revision string
VER_FULLSTR		= $(VER_MAJOR).$(VER_MINOR).$(VER_BUILDNUM)$(VER_EXTRA)

# if this is an SVN release, include the SVN revision in the version string
ifneq ($(VER_SVNREV),0)
    VER_FULLSTR	+= (svn $(VER_SVNREV))
endif


####
# Build-type specific configuration
####
ifeq ($(BUILD_TYPE),debug)
	CFLAGS		+= -g -ggdb
	CXXFLAGS	+= -g -ggdb
else
 ifeq ($(BUILD_TYPE),release)
	CFLAGS		+= -O2
	CXXFLAGS	+= -O2
 else
 	$(error Unsupported build type: '$(BUILD_TYPE)')
 endif
endif

####
# rules
####

# object files
OBJ		=	$(addprefix obj/, $(addsuffix .o, $(basename $(SRC))) $(EXT_OBJ)) $(addsuffix .o, $(basename $(EXTSRC)))

# dependency files
DEPFILES =	$(addprefix dep/, $(addsuffix .d, $(basename $(SRC))) $(EXT_OBJ)) $(addsuffix .d, $(basename $(EXTSRC)))

# path commands
LIBLNK	=	$(addprefix -l, $(LIB))
LIBPTH	=	$(addprefix -L, $(LIBPATH))
INCPTH	=	$(addprefix -I, $(INCPATH))

CPPFLAGS +=	$(INCPTH)

####
# Make sure there is at least one object file to be linked in
####
ifeq ($(strip $(OBJ)),)
    $(error Unable to build: no object or source files specified in Makefile)
endif

####
# targets
####
.PHONY:	default all update-revision versionheader clean-versioninfo init cleandep clean tidy

all:	update-revision
	@$(MAKE) versionheader
	$(MAKE) $(TARGET)

# increment the current build number
NEWBUILD=$(shell expr $(VER_BUILDNUM) + 1)
update-revision:
	@echo $(NEWBUILD) > .buildnum

versionheader:
	@sed -e 's/@@date@@/$(shell LC_ALL=C date)/g'			\
		 -e 's/@@time@@/$(shell LC_ALL=C date +%T)/g'		\
		 -e 's/@@whoami@@/$(shell whoami)/g'				\
		 -e 's/@@hostname@@/$(shell hostname)/g'			\
		 -e 's|@@compiler@@|$(shell $(CC) $(CFLAGS) -v 2>&1 | tail -n 1 | sed -e "s;|;/;")|g'	\
		 -e 's/@@majorver@@/$(VER_MAJOR)/g'					\
		 -e 's/@@minorver@@/$(VER_MINOR)/g'					\
		 -e 's/@@extraver@@/$(subst \",,$(VER_EXTRA))/g'	\
		 -e 's/@@buildnum@@/$(VER_BUILDNUM)/g'				\
		 -e 's/@@buildtype@@/$(BUILD_TYPE)/g'				\
		 -e 's/@@svnrev@@/$(VER_SVNREV)/g'					\
		 -e 's/@@fullverstr@@/$(VER_FULLSTR)/g'				\
		 -e 's/@@cflags@@/$(CFLAGS)/g'						\
		 < src/version.h.in > src/version.h

# version.h creation stuff based on code from the Xen makefile
clean-versioninfo:
	@if [ ! -r src/version.h -o -O src/version.h ]; then \
		rm -f src/version.h; \
	fi
	@echo 0 > .buildnum

# initialise the build system for a new project
init:
	@mkdir -p src dep obj
	@echo 0 > .buildnum
	@echo '#define VER_COMPILE_DATE	"@@date@@"'				> src/version.h.in
	@echo '#define VER_COMPILE_TIME	"@@time@@"'				>> src/version.h.in
	@echo '#define VER_COMPILE_BY		"@@whoami@@"'		>> src/version.h.in
	@echo '#define VER_COMPILE_HOST	"@@hostname@@"'			>> src/version.h.in
	@echo '#define VER_COMPILER		"@@compiler@@"'			>> src/version.h.in
	@echo '#define VER_BUILD_TYPE		"@@buildtype@@"'	>> src/version.h.in
	@echo '#define VER_CFLAGS			"@@cflags@@"'		>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo '#define VER_MAJOR			@@majorver@@'		>> src/version.h.in
	@echo '#define VER_MINOR			@@minorver@@'		>> src/version.h.in
	@echo '#define VER_BUILDNUM		@@buildnum@@'			>> src/version.h.in
	@echo '#define VER_EXTRA			"@@extraver@@"'		>> src/version.h.in
	@echo '#define VER_SVNREV			@@svnrev@@'			>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo '#define VER_FULLSTR			"@@fullverstr@@"'	>> src/version.h.in
	@echo ''												>> src/version.h.in
	@echo Build system initialised

# remove the dependency files
cleandep:
	-rm $(DEPFILES)

# remove the dependency files and any target or intermediate build files
clean:	cleandep clean-versioninfo
	-rm $(OBJ) $(TARGET) $(GARBAGE)

# remove any dependency or intermediate build files
tidy:	cleandep clean-versioninfo
	-rm $(OBJ) $(GARBAGE)

#################################

$(TARGET):	$(OBJ) $(EXTDEP)
ifeq ($(SRC_TYPE),c)
	$(CC) $(CXXFLAGS) $(LDFLAGS) $(OBJ) $(LIBPTH) $(LIBLNK) -o $@
else
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(OBJ) $(LIBPTH) $(LIBLNK) -o $@
endif
ifeq ($(BUILD_TYPE),release)
	$(STRIP) $(TARGET)
endif

###
# extra rules
# example:
#src/parser.c:	src/parser.h

####
# make object files from C source files
obj/%.o:	src/%.c
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $@

##
# make object files from C++ source files
obj/%.o:	src/%.cc
	$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $< -o $@

obj/%.o:	src/%.cpp
	$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $< -o $@

###
# make C files from yacc/bison source
src/%.h src/%.c:	src/%.y
	$(YACC) $(YFLAGS) -d $<
	mv -f y.tab.c $*.c
	mv -f y.tab.h $*.h

###
# make C files from lex/flex source
src/%.c:	src/%.l
	$(LEX) $(LFLAGS) -o$@ $<

###
# make dependencies for our source files
dep/%.d:	src/%.c
	$(CC) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

dep/%.d:	src/%.cpp
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

dep/%.d:	src/%.cc
	$(CXX) -MM $(CPPFLAGS) $< > $@.$$$$; \
		sed 's,\($*\)\.o[ :]*,obj/\1.o $@ : ,g' < $@.$$$$ > $@; \
		rm -f $@.$$$$

####
# pull in the dependency files, but only for 'make $(TARGET)'
####

ifeq ($(MAKECMDGOALS),$(TARGET))
  -include $(DEPFILES)
endif

=== PTdecode/CImg-1.3.0/examples/Makefile ===
#
#  File        : Makefile
#                ( Makefile for GNU 'make' utility )
#
#  Description : Makefile for compiling CImg-based code on Unix.
#                This file is a part of the CImg Library project.
#                ( http://cimg.sourceforge.net )
#
#  Copyright   : David Tschumperle
#                ( http://www.greyc.ensicaen.fr/~dtschump/ )
#
#  License     : CeCILL v2.0
#                ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html )
#
#  This software is governed by the CeCILL  license under French law and
#  abiding by the rules of distribution of free software.  You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  "http://www.cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL license and that you accept its terms.
#

#-------------------------------------------------------
# Define the list of files to be compiled
# (name of the source files without the .cpp extension)
#-------------------------------------------------------
CIMG_FILES = CImg_demo \
	     captcha \
             curve_editor \
	     dtmri_view \
	     edge_explorer \
	     fade_images \
             generate_loop_macros \
	     greycstoration \
	     hough_transform \
	     image_registration \
	     image2ascii \
	     image_surface \
	     jawbreaker \
	     mcf_levelsets \
	     mcf_levelsets3d \
	     odykill \
	     pde_heatflow2d \
	     pde_TschumperleDeriche2d \
	     radon_transform \
	     scene3d \
	     tetris \
	     tron \
	     tutorial \
	     wavelet_atrous \
	     use_draw_gradient \
	     use_greycstoration \
	     use_nlmeans \
	     use_skeleton \
	     use_RGBclass \
	     gmic

#---------------------------------
# Set correct variables and paths
#---------------------------------
CIMG_VERSION = 1.30
X11PATH      = /usr/X11R6
CC           = g++
CCVER        = `$(CC) -v 2>&1 | tail -n 1`
EXEPFX       =

ifeq ($(CC),icc)
CFLAGS       = -I.. -ansi
LDFLAGS      =
else
CFLAGS       = -I.. -Wall -W -ansi -pedantic
LDFLAGS      = -lm
endif

#--------------------------------------------------
# Set compilation flags allowing to customize CImg
#--------------------------------------------------

# Flags to enable code debugging.
CIMG_DEBUG_CFLAGS = -Dcimg_debug=3 -g

# Flags to enable color output messages.
# (requires a VT100 compatible terminal)
CIMG_VT100_CFLAGS = -Dcimg_use_vt100

# Flags to enable code optimization by the compiler.
ifeq ($(CC),icc)
CIMG_OPT_CFLAGS = -O3 -ipo -no-prec-div
else
CIMG_OPT_CFLAGS = -O3 -ffast-math -fno-tree-pre
endif

# Flags to enable OpenMP support.
ifeq ($(CC),icc)
CIMG_OPENMP_CFLAGS = -Dcimg_use_openmp -openmp -i-static
else
CIMG_OPENMP_CFLAGS = -Dcimg_use_openmp -fopenmp
endif

# Flags used to disable display capablities of CImg
CIMG_NODISPLAY_CFLAGS = -Dcimg_display=0

# Flags to enable the use of the X11 library.
# (X11 is used by CImg to handle display windows)
# !!! For 64bits systems : replace -L$(X11PATH)/lib by -L$(X11PATH)/lib64 !!!
CIMG_X11_CFLAGS = -I$(X11PATH)/include
CIMG_X11_LDFLAGS = -L$(X11PATH)/lib -lpthread -lX11

# Flags to enable GDI32 display (Windows native).
CIMG_GDI32_CFLAGS = -mwindows
CIMG_GDI32_LDFLAGS = -lgdi32

# Flags to enable Carbon-based display (MacOSX native).
CIMG_CARBON_CFLAGS = -Dcimg_display=3 -framework Carbon

# Flags to enable fast image display, using the XSHM library (when using X11).
CIMG_XSHM_CFLAGS = -Dcimg_use_xshm
CIMG_XSHM_LDFLAGS = -lXext

# Flags to enable screen mode switching, using the XRandr library (when using X11).
# ( http://www.x.org/wiki/Projects/XRandR )
CIMG_XRANDR_CFLAGS = -Dcimg_use_xrandr
CIMG_XRANDR_LDFLAGS = -lXrandr

# Flags to enable native support for PNG image files, using the PNG library.
# ( http://www.libpng.org/ )
CIMG_PNG_CFLAGS = -Dcimg_use_png
CIMG_PNG_LDFLAGS = -lpng -lz

# Flags to enable native support for JPEG image files, using the JPEG library.
# ( http://www.ijg.org/ )
CIMG_JPEG_CFLAGS = -Dcimg_use_jpeg
CIMG_JPEG_LDFLAGS = -ljpeg

# Flags to enable native support for TIFF image files, using the TIFF library.
# ( http://www.libtiff.org/ )
CIMG_TIFF_CFLAGS = -Dcimg_use_tiff
CIMG_TIFF_LDFLAGS = -ltiff

# Flags to enable native support for various video files, using the FFMPEG library.
# ( http://www.ffmpeg.org/ )
CIMG_FFMPEG_CFLAGS = -Dcimg_use_ffmpeg -I/usr/include/ffmpeg
CIMG_FFMPEG_LDFLAGS = -lavcodec -lavformat

# Flags to enable native support for compressed .cimgz files, using the Zlib library.
# ( http://www.zlib.net/ )
CIMG_ZLIB_CFLAGS = -Dcimg_use_zlib
CIMG_ZLIB_LDFLAGS = -lz

# Flags to enable native support of most classical image file formats, using the Magick++ library.
# ( http://www.imagemagick.org/Magick++/ )
CIMG_MAGICK_CFLAGS = -Dcimg_use_magick `Magick++-config --cppflags` `Magick++-config --cxxflags`
CIMG_MAGICK_LDFLAGS = `Magick++-config --ldflags` `Magick++-config --libs`

# Flags to enable faster Discrete Fourier Transform computation, using the FFTW3 library
# ( http://www.fftw.org/ )
CIMG_FFTW3_CFLAGS = -Dcimg_use_fftw3
ifeq ($(MSYSTEM),MINGW32)
CIMG_FFTW3_LDFLAGS = -lfftw3-3
else
CIMG_FFTW3_LDFLAGS = -lfftw3
endif

# Flags to enable the use of LAPACK routines for matrix computation
# ( http://www.netlib.org/lapack/ )
CIMG_LAPACK_CFLAGS = -Dcimg_use_lapack
CIMG_LAPACK_LDFLAGS = -lblas -lg2c -llapack

# Flags to enable the use of the Board library
# ( http://libboard.sourceforge.net/ )
CIMG_BOARD_CFLAGS = -Dcimg_use_board -I/usr/include/board
CIMG_BOARD_LDFLAGS = -lboard

# Flags to compile on Sun Solaris
CIMG_SOLARIS_LDFLAGS = -R$(X11PATH)/lib -lrt -lnsl -lsocket

# Flags to compile GIMP plug-ins.
ifeq ($(MSYSTEM),MINGW32)
CIMG_GIMP_CFLAGS = -mwindows
endif

#-------------------------
# Define Makefile entries
#-------------------------
.cpp:
	@echo
	@echo "** Compiling '$* ($(CIMG_VERSION))' with '`$(CC) -v 2>&1 | tail -n 1`'"
	@echo
	$(CC) -o $(EXEPFX)$* $< $(CFLAGS) $(LDFLAGS) $(CONF_CFLAGS) $(CONF_LDFLAGS)
ifeq ($(MACOSX_APP),true)
	mkdir -p $(EXEPFX)${*}.app/Contents/MacOS
	mv $(EXEPFX)${*} $(EXEPFX)${*}.app/Contents/MacOS
endif
ifeq ($(STRIP_EXE),true)
ifeq ($(MSYSTEM),MINGW32)
	strip $(EXEPFX)$*.exe
else
	strip $(EXEPFX)$*
endif
endif
menu:
	@echo
	@echo "CImg Library $(CIMG_VERSION) : Examples"
	@echo "-----------------------------"
	@echo "  > linux    : Linux/BSD/MacOSX target, X11 display, optimizations disabled."
	@echo "  > dlinux   : Linux/BSD/MacOSX target, X11 display, debug mode."
	@echo "  > olinux   : Linux/BSD/MacOSX target, X11 display, optimizations enabled."
	@echo "  > mlinux   : Linus/BSD/MacOSX target, no display, minimal features, optimizations enabled."
	@echo "  > Mlinux   : Linux/BSD/MacOSX target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > solaris  : Sun Solaris target, X11 display, optimizations disabled."
	@echo "  > dsolaris : Sun Solaris target, X11 display, debug mode."
	@echo "  > osolaris : Sun Solaris target, X11 display, optimizations enabled."
	@echo "  > msolaris : Sun Solaris target, no display, minimal features, optimizations enabled."
	@echo "  > Msolaris : Sun Solaris target, X11 display, maximal features, optimizations enabled."
	@echo
	@echo "  > macosx   : MacOSX target, Carbon display, optimizations disabled."
	@echo "  > dmacosx  : MacOSX target, Carbon display, debug mode."
	@echo "  > omacosx  : MacOSX target, Carbon display, optimizations enabled."
	@echo "  > mmacosx  : MacOSX target, no display, minimal features, optimizations enabled."
	@echo "  > Mmacosx  : MacOSX target, Carbon display, maximal features, optimizations enabled."
	@echo
	@echo "  > windows  : Windows target, GDI32 display, optimizations disabled."
	@echo "  > dwindows : Windows target, GDI32 display, debug mode."
	@echo "  > owindows : Windows target, GDI32 display, optimizations enabled."
	@echo "  > mwindows : Windows target, no display, minimal features, optimizations enabled."
	@echo "  > Mwindows : Windows target, GDI32 display, maximal features, optimizations enabled."
	@echo
	@echo "  > clean    : Clean generated files."
	@echo
	@echo "Choose your option :"
	@read CHOICE; echo; make $$CHOICE; echo; echo "> Next time, you can bypass the menu by typing directly 'make $$CHOICE'"; echo;

all: $(CIMG_FILES)

clean:
	rm -rf *.app *.exe *.o *~ \#* CMakeFiles cmake_install.cmake CMakeCache.txt use_jpeg_buffer greycstoration4gimp gmic4gimp $(CIMG_FILES)
ifneq ($(EXEPFX),)
	rm -f $(EXEPFX)*
endif

# Specific target for 'check_all_functions'.
check: check_all_functions.cpp
	@echo
	@echo "** Compiling 'check_all_functions ($(CIMG_VERSION)) ' with '$(CCVER)'"
	@echo
	$(CC) -c check_all_functions.cpp $(CFLAGS)

# Specific target for the 'greycstoration4gimp' plug-in for GIMP.
greycstoration4gimp: greycstoration4gimp.cpp
	@echo
	@echo "** Compiling 'greycstoration4gimp ($(CIMG_VERSION))' with '$(CCVER)'"
	@echo
	$(CC) -I.. -I./plugins -o $(EXEPFX)greycstoration4gimp greycstoration4gimp.cpp `gimptool-2.0 --cflags` `gimptool-2.0 --libs` -lpthread $(CIMG_OPT_CFLAGS) $(CIMG_GIMP_CFLAGS)

# Specific targets for the 'gmic4gimp' plug-in for GIMP.
gmic4gimp_def: gmic4gimp_def.raw
	\gmic -v- -t char gmic4gimp_def.raw,`du -Db gmic4gimp_def.raw | awk '{print $$1}'` -o -.h | sed 's/unnamed/gmic4gimp_def/' | sed 's/char/const char/' > gmic4gimp_def.h
	\gmic -v- -t uchar ../html/img/logoGMIC.ppm -permute vxyz -o -.h | sed 's/unnamed/logo/' | sed 's/char/const char/' >> gmic4gimp_def.h

gmic4gimp.o: gmic.cpp
	$(CC) -I.. -o gmic4gimp.o -c gmic.cpp -Dgmic_minimal $(CIMG_OPT_CFLAGS) $(CIMG_FFTW3_CFLAGS)

gmic4gimp: gmic4gimp.o gmic4gimp.cpp
	$(CC) -I.. -I./plugins -o $(EXEPFX)gmic4gimp gmic4gimp.cpp gmic4gimp.o `gimptool-2.0 --cflags` `gimptool-2.0 --libs` -lpthread $(CIMG_OPT_FLAGS) $(CIMG_FFTW3_LDFLAGS) $(CIMG_GIMP_CFLAGS)

# Specific targets for 'gmic'.
gmic_def: gmic_def.raw
	\gmic -v- -t char gmic_def.raw,`du -Db gmic_def.raw | awk '{print $$1}'` -o -.h | sed 's/ \};/, 0 \};/g' | sed 's/unnamed/def/' > gmic_def.h

gmic_bool.o: gmic.cpp
	@echo
	@echo "** Compiling 'gmic ($(CIMG_VERSION))' with '$(CCVER)'"
	@echo
	$(CC) -o gmic_bool.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_bool $(CFLAGS) $(CONF_CFLAGS)
gmic_uchar.o: gmic.cpp
	$(CC) -o gmic_uchar.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_uchar $(CFLAGS) $(CONF_CFLAGS)
gmic_char.o: gmic.cpp
	$(CC) -o gmic_char.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_char $(CFLAGS) $(CONF_CFLAGS)
gmic_ushort.o: gmic.cpp
	$(CC) -o gmic_ushort.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_ushort $(CFLAGS) $(CONF_CFLAGS)
gmic_short.o: gmic.cpp
	$(CC) -o gmic_short.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_short $(CFLAGS) $(CONF_CFLAGS)
gmic_uint.o: gmic.cpp
	$(CC) -o gmic_uint.o -c gmic.cpp -I. -Dgmic_separate_compilation -Dgmic_uint $(CFLAGS) $(CONF_CFLAGS)
gmic_int.o: gmic.cpp

=== PTdecode/CImg-1.3.0/resources/CMakeLists.txt ===
#
#  File        : CMakeLists.txt
#                ( Cmake configuration file )
#
#  Description : CMake can use this to generate a working Makefile.
#                This file is a part of the CImg Library project.
#                ( http://cimg.sourceforge.net )
#
#  Copyright   : Baptiste Mougel
#                ( http://www.mougel.org )
#                David Tschumperle
#                ( http://www.greyc.ensicaen.fr/~dtschump/ )
#
#  License     : CeCILL v2.0
#                ( http://www.cecill.info/licences/Licence_CeCILL_V2-en.html )
#
#  This software is governed by the CeCILL  license under French law and
#  abiding by the rules of distribution of free software.  You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  "http://www.cecill.info".
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  In this respect, the user's attention is drawn to the risks associated
#  with loading,  using,  modifying and/or developing or reproducing the
#  software by the user in light of its specific status of free software,
#  that may mean  that it is complicated to manipulate,  and  that  also
#  therefore means  that it is reserved for developers  and  experienced
#  professionals having in-depth computer knowledge. Users are therefore
#  encouraged to load and test the software's suitability as regards their
#  requirements in conditions enabling the security of their systems and/or
#  data to be ensured and,  more generally, to use and operate it in the
#  same conditions as regards security.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL license and that you accept its terms.
#

#-------------------
# IMPORTANT NOTICE : This file is intended to be copied in the 'examples/' directory before use.
#-------------------
project(CIMG)

IF(UNIX)
   CMAKE_MINIMUM_REQUIRED (VERSION 2.4.0 FATAL_ERROR)
   MESSAGE(STATUS "Compilation mode : UNIX")
ELSE(UNIX)
  IF(WIN32)
    CMAKE_MINIMUM_REQUIRED(VERSION 2.4.6 FATAL_ERROR)
    MESSAGE(STATUS "Compilation mode : Win32")
  ELSE(WIN32)
    IF(APPLE)
       CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)
       IF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
         MESSAGE("Warning: A critical CMake bug exists in 2.4.6 and below. Trying to build Universal Binaries will result in a compile error that seems unrelated. Either avoid building Universal Binaries by changing the CMAKE_OSX_ARCHITECTURES field to list only your architecture, or upgrade to the current CVS version of CMake or a newer stable version if it exists.")
       ENDIF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
       MESSAGE(STATUS "Compilation mode : MAC OSX")
    ELSE(APPLE)
        CMAKE_MINIMUM_REQUIRED(VERSION 2.4.0 FATAL_ERROR)
    ENDIF(APPLE)
  ENDIF(WIN32)
ENDIF(UNIX)

#-----------------------------------------------------------------------------
# CImg version number.  An even minor number corresponds to releases.
SET(CIMG_VERSION "1.3.0")
SET(CIMG_H "CImg.h")

MESSAGE(STATUS "CImg version : ${CIMG_VERSION}")

#-----------------------------------------------------------------------------
# Output directories.
INCLUDE_DIRECTORIES (
  ${CIMG_BINARY_DIR}
  ${CIMG_SOURCE_DIR}
)

IF(NOT LIBRARY_OUTPUT_PATH)
   SET (LIBRARY_OUTPUT_PATH ${CIMG_BINARY_DIR}/ CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
   SET (EXECUTABLE_OUTPUT_PATH ${CIMG_BINARY_DIR}/ CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

#MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

#-----------------------------------------------------------------------------
# Compilation.

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -W -ansi -pedantic")
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -W -ansi -pedantic")
SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lm -lpthread")
SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lm -lpthread")
SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lm -lpthread")

OPTION(BUILD_EXAMPLES "Build the Examples directory." ON)
IF (BUILD_EXAMPLES)
	ADD_EXECUTABLE(CImg_demo CImg_demo.cpp)
	ADD_EXECUTABLE(captcha captcha.cpp)
	ADD_EXECUTABLE(curve_editor curve_editor.cpp)
	ADD_EXECUTABLE(dtmri_view dtmri_view.cpp)
	ADD_EXECUTABLE(edge_explorer edge_explorer.cpp)
	ADD_EXECUTABLE(fade_images fade_images.cpp)
	ADD_EXECUTABLE(generate_loop_macros generate_loop_macros.cpp)
        ADD_EXECUTABLE(gmic gmic.cpp)
	ADD_EXECUTABLE(greycstoration greycstoration.cpp)
	ADD_EXECUTABLE(hough_transform hough_transform.cpp)
	ADD_EXECUTABLE(image2ascii image2ascii.cpp)
	ADD_EXECUTABLE(image_registration image_registration.cpp)
	ADD_EXECUTABLE(image_surface image_surface.cpp)
	ADD_EXECUTABLE(jawbreaker jawbreaker.cpp)
	ADD_EXECUTABLE(mcf_levelsets3d mcf_levelsets3d.cpp)
	ADD_EXECUTABLE(mcf_levelsets mcf_levelsets.cpp)
	ADD_EXECUTABLE(odykill odykill.cpp)
	ADD_EXECUTABLE(pde_heatflow2d pde_heatflow2d.cpp)
	ADD_EXECUTABLE(pde_TschumperleDeriche2d pde_TschumperleDeriche2d.cpp)
	ADD_EXECUTABLE(radon_transform radon_transform.cpp)
	ADD_EXECUTABLE(scene3d scene3d.cpp)
	ADD_EXECUTABLE(tetris tetris.cpp)
	ADD_EXECUTABLE(tron tron.cpp)
	ADD_EXECUTABLE(tutorial tutorial.cpp)
	ADD_EXECUTABLE(wavelet_atrous wavelet_atrous.cpp)
	ADD_EXECUTABLE(use_draw_gradient use_draw_gradient.cpp)
	ADD_EXECUTABLE(use_greycstoration use_greycstoration.cpp)
	ADD_EXECUTABLE(use_nlmeans use_nlmeans.cpp)
	ADD_EXECUTABLE(use_RGBclass use_RGBclass.cpp)
	ADD_EXECUTABLE(use_skeleton use_skeleton.cpp)
ENDIF (BUILD_EXAMPLES)

# Flags to enable code debugging.
OPTION(CIMG_DEBUG_FLAGS "Flags to enable code debugging." OFF)
IF (CIMG_DEBUG_FLAGS)
  ADD_DEFINITIONS(-Dcimg_debug=3)
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
ENDIF(CIMG_DEBUG_FLAGS)

# Flags to enable color output messages.
# (requires a VT100 compatible terminal)
OPTION(CIMG_VT100_FLAGS "Flags to enable color output messages. (requires a VT100 compatible terminal)" ON)
IF (CIMG_VT100_FLAGS)
  ADD_DEFINITIONS(-Dcimg_use_vt100)
ENDIF(CIMG_VT100_FLAGS)

# Flags to enable code optimization by the compiler.
OPTION(CIMG_OPT_FLAGS "Flags to enable code optimization by the compiler." ON)
IF (CIMG_OPT_FLAGS)
   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -ffast-math")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ffast-math")
ENDIF(CIMG_OPT_FLAGS)

# Flags to enable OpenMP support.
OPTION(CIMG_OPENMP_FLAGS "Flags to enable code optimization by the compiler." OFF)
IF (CIMG_OPENMP_FLAGS)
   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fopenmp")
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fopenmp")
   ADD_DEFINITIONS(-Dcimg_use_openmp)
ENDIF(CIMG_OPENMP_FLAGS)

# Flags to enable the use of the X11 library.
# (X11 is used by CImg to handle display windows)
# !!! For 64bits systems : replace -L$(X11PATH)/lib by -L$(X11PATH)/lib64 !!!
OPTION(CIMG_X11_FLAGS "Flags to enable fast image display, using the XSHM library." ON)
IF (CIMG_X11_FLAGS)

  FIND_PATH(X11_PATH /bin/xterm /usr/X11R6)

  OPTION(CIMG_SYSTEMS_64BITS "For 64bits systems." OFF)
  IF (CIMG_SYSTEMS_64BITS)
    INCLUDE_DIRECTORIES(${X11_PATH}/include)
    LINK_DIRECTORIES(${X11_PATH}/lib64)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -L${X11_PATH}/lib64 -lX11")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -L${X11_PATH}/lib64 -lX11")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -L${X11_PATH}/lib64 -lX11")
  ELSE (CIMG_SYSTEMS_64BITS)
    INCLUDE_DIRECTORIES(${X11_PATH}/include)
    LINK_DIRECTORIES(${X11_PATH}/lib)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -L${X11_PATH}/lib -lX11")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -L${X11_PATH}/lib -lX11")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -L${X11_PATH}/lib -lX11")
  ENDIF(CIMG_SYSTEMS_64BITS)

  # Flags to enable fast image display, using the XSHM library.
  # (CIMG_X11_FLAGS must be defined also)
  OPTION(CIMG_XSHM_FLAGS "Flags to enable fast image display, using the XSHM library." ON)
  IF (CIMG_XSHM_FLAGS)
    ADD_DEFINITIONS(-Dcimg_use_xshm)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lXext")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lXext")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lXext")
  ENDIF(CIMG_XSHM_FLAGS)

  # Flags to enable screen mode switching, using the XRandr library.
  # (CIMG_X11_FLAGS must be defined also)
  OPTION(CIMG_XRANDR_FLAGS "Flags to enable screen mode switching, using the XRandr library." ON)
  IF (CIMG_XRANDR_FLAGS)
    ADD_DEFINITIONS(-Dcimg_use_xrandr)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lXrandr")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lXrandr")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lXrandr")
  ENDIF(CIMG_XRANDR_FLAGS)

  # Flags to compile on Solaris
  #CIMG_SOLARIS_FLAGS = -R$(X11PATH)/lib -lrt -lnsl -lsocket
  OPTION(CIMG_SOLARIS_FLAGS "Flags to compile on Solaris." OFF)
  IF (CIMG_SOLARIS_FLAGS)
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -R$(X11_PATH)/lib -lrt -lnsl -lsocket")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -R$(X11_PATH)/lib -lrt -lnsl -lsocket")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -R$(X11_PATH)/lib -lrt -lnsl -lsocket")
  ENDIF(CIMG_SOLARIS_FLAGS)

ENDIF(CIMG_X11_FLAGS)


# Flags to enable native support for PNG image files, using the PNG library.
#CIMG_PNG_FLAGS = -Dcimg_use_png -lpng -lz
OPTION(CIMG_PNG_FLAGS "Flags to enable native support for PNG image files, using the PNG library." OFF)
IF (CIMG_PNG_FLAGS)
  ADD_DEFINITIONS(-Dcimg_use_png)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lpng -lz")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lpng -lz")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -lpng -lz")
ENDIF(CIMG_PNG_FLAGS)

# Flags to enable native support for JPEG image files, using the JPEG library.
#CIMG_JPEG_FLAGS = -Dcimg_use_jpeg -ljpeg
OPTION(CIMG_JPEG_FLAGS "Flags to enable native support for JPEG image files, using the JPEG library." OFF)
IF (CIMG_JPEG_FLAGS)
  ADD_DEFINITIONS(-Dcimg_use_jpeg)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ljpeg")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ljpeg")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ljpeg")
ENDIF(CIMG_JPEG_FLAGS)

# Flags to enable native support for TIFF image files, using the TIFF library.
#CIMG_TIFF_FLAGS = -Dcimg_use_tiff -ltiff
OPTION(CIMG_TIFF_FLAGS "Flags to enable native support for TIFF image files, using the TIFF library." OFF)
IF (CIMG_TIFF_FLAGS)
  ADD_DEFINITIONS(-Dcimg_use_tiff)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ltiff")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ltiff")
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ltiff")
ENDIF(CIMG_TIFF_FLAGS)

# Flags to enable native support for various video files, using the FFMPEG library.
#CIMG_FFMPEG_FLAGS = -Dcimg_use_ffmpeg -lavcodec -lavformat
OPTION(CIMG_FFMPEG_FLAGS "Flags to enable native support for various video files, using the FFMPEG library." OFF)
IF (CIMG_FFMPEG_FLAGS)
  ADD_DEFINITIONS(-Dcimg_use_ffmpeg)
  SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lavcodec -lavformat")
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lavcodec -lavformat")

=== PTdecode/CImg-1.3.0/resources/debian/control ===
Source: cimg
Section: math
Priority: optional
Maintainer: Sam Hocevar (Debian packages) <sam+deb@zoy.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, François-Xavier Dupé <Francois-Xavier.Dupe@greyc.ensicaen.fr>
Build-Depends-Indep: libx11-dev
Build-Depends: debhelper (>= 5.0)
Standards-Version: 3.7.2.2

Package: cimg-dev
Depends: make | build-essential, libx11-dev, libxrandr-dev, imagemagick | graphicsmagick
Suggests: xmedcon, lapack3-dev, libmagick++9-dev, fftw3-dev
Architecture: all
Description: C++ Template Image Processing Library
 The CImg Library is an open-source C++ toolkit for image processing.
 It consists in a single header file 'CImg.h' providing a set of C++ classes
 and functions that can be used in your own sources, to load/save, process
 and display images. Very portable (Unix/X11,Windows, MacOS X, FreeBSD,..),
 efficient, easy to use, it's a pleasant toolkit for coding image processing
 stuffs in C++.
